
#include <inttypes.h>
#include <avr/io.h>
#include <avr/eeprom.h>
#include "../common_files/eeprom.h"
#include "../common_files/status_structs.h"
// extern structs


BOARD_STATUS board_status;

//testmethods for eeprom reading and writing
void eeprom_read_params(void){
    uint8_t *p8 = (uint8_t *) EEPROM_START;
    uint16_t *p16;
    //if (eeprom_read_byte (p8++) != EEPROM_KEY) return;

    p16 = (uint16_t *) p8;
    board_status.times_powered_on = eeprom_read_word(p16++);
}


void eeprom_write_params (void){
    uint8_t *p8 = (uint8_t *) EEPROM_START;
    uint16_t *p16;
    p16 = (uint16_t *) p8;
    eeprom_write_word (p16++, board_status.times_powered_on);

}

//0x0000 means the bootloader will start if watchdogreset occurs
//0xcafe means the program will start if watchdogreset occurs
void eepromResetBootByte(void){
	uint8_t *p8 = (uint8_t *) EEPROM_BOOTBYTE_ADDR;
	uint16_t *p16;
    p16 = (uint16_t *) p8;
    eeprom_write_word (p16, 0x0000);

}

void add_to_PowerOnCount(void){
	eeprom_read_params();
	board_status.times_powered_on++;
	eeprom_write_params();
}

