#ifndef __INCLUDE_MACRO_H
#define __INCLUDE_MACRO_H

typedef char bool;
#define TRUE 1
#define FALSE 0

#ifndef NULL
#define NULL ((void*)0)
#endif

#define SET_BIT(var, n) (var |= (1 << n))
#define CLEAR_BIT(var, n) (var &= ~(1 << n))
#define TEST_BIT(var, n) ((var & (1 << n)) != 0)

#include "config.h"
#include <util/delay.h>

#define _DELAY_MS(msec) do { if ((msec)<10) _delay_ms(msec); else \
	{int cntr; for(cntr=0; cntr<(msec); cntr+=10) _delay_ms(10);}} while (0)

#define _DELAY_US(usec) do { if ((usec)<10) _delay_us(usec); else \
	{int cntr; for(cntr=0; cntr<(usec); cntr+=10) _delay_us(10);}} while (0)

#endif // __INCLUDE_MACRO_H
