/* rev 1.0 2/2010 				written by Anders Guldahl			     */
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>
#include <avr/pgmspace.h>
#include "macro.h"
#include "led_driver.h"


void init_led_driver(void){

	//set as output
	PORTE &= ~((1<<PE3)|(1<<PE4)|(1<<PE5));
	DDRE |= (1<<PE3)|(1<<PE4)|(1<<PE5);

	PORTB &= ~(1<<PB4);
	DDRB |= (1<<PB4);



	//init 16bit timer
	//Mode 14, Fast PWM (se s137 i datablad)
	SET_BIT(TCCR3B, WGM33);
	SET_BIT(TCCR3B, WGM32);
	SET_BIT(TCCR3A, WGM31);
	CLEAR_BIT(TCCR3A, WGM30);

	//Setter pwm-utgang lav p compare match,
	//for output compare a, b og c
	SET_BIT(TCCR3A, COM3A1);
	CLEAR_BIT(TCCR3A, COM3A0);
	SET_BIT(TCCR3A, COM3B1);
	CLEAR_BIT(TCCR3A, COM3B0);
	SET_BIT(TCCR3A, COM3C1);
	CLEAR_BIT(TCCR3A, COM3C0);

	//Sett CSn2:0 for prescaler = clk / 256
	SET_BIT(TCCR3B, CS32);
	CLEAR_BIT(TCCR3B, CS31);
	CLEAR_BIT(TCCR3B, CS30);

	//Sett toppverdi (periode)
	ICR3H = 0;
	ICR3L =  0xff;

	//set off
	OCR3AL = 0x00;
	OCR3BL = 0x00;
	OCR3CL = 0x00;


	//timer2 pb4

	TCCR2A = (1<<WGM20)|(1<<WGM21)|(1<<COM2A1)|(1 << CS22)|(1<<CS21);
	OCR2A = 0x00;

}


