
#ifndef MOTOR_H
#define MOTOR_H


typedef struct{
	enum {
		PECCP50_SYNCH,
		PECCP50_LEN,
		PECCP50_LSUM,
		PECCP50_DATA,
		PECCP50_ESUM,
		PECCP50_VALID
	} state;

	int pos;
	int len;
	unsigned char lastff;
	unsigned char *iter;
	unsigned char buf[254];
	unsigned char sum;
}PECCP50;


int PECCP50Decode(PECCP50 *peccp50,int data);
void MotorSend(int len, char data[]);
void MotorPing(void);
void MotorStart(void);
void MotorStartWithError(void);
void MotorStartMotor(void);
void MotorStop(void);
void MotorReset(void);
void MotorSetSpeedRef(int16_t speed_rpm);
void MotorGetSpeedRef(void);
void MotorGetSpeed(void);
void SkrivMotorError(uint8_t ec);
int MotorGetVoltage(void);

#endif
