
/************************************************************************* 
* description:  uartdriver for avr 128
**************************************************************************/
#ifndef __INCLUDE_uart_driver_H__
#define __INCLUDE_uart_driver_H__


#define UART_BAUD_motor 115200
#define BAUDREG_motor   ((unsigned int)((F_CPU * 10) / (8UL * UART_BAUD_motor) - 5) / 10)


// size must be in range 2 .. 256
#define RX0_SIZE	32		// usable: RX0_SIZE + 2 (4 .. 258)
#define TX0_SIZE	32		// usable: TX0_SIZE + 1 (3 .. 257)

#define UART_NO_DATA 0x0100

void USART_Init(void);

//0 = rx buffer empty
unsigned char ukbhit0( void );

uint16_t ugetchar0( void );

unsigned char utx0_ready( void );

void uputchar( unsigned char c );

void uputs( unsigned char *s );

void uart_puts_P(const char *s);

//fill buffer up to size, returns int with how many char's written to buffer
int ugets(unsigned char *buffer, int size);

void USART_rx_flush( void );

#endif //ifndef __INCLUDE_uart_driver_H__
