/* rev 1.0 12/2009 				written by Anders Guldahl			     */
// SOURCE FILE : SPI_routines.c

#include <avr/io.h>
#include "SPI_routines.h"

//SPI initialize for SD card

void spi_init(void){

	/* Set chipselect high*/
	SW_IO_CS_DEASSERT;
	LED_IO_CS_DEASSERT;

	/* Set MOSI and SCK and pb0 output, all others input */
	DDRB |= (1<<PB2)|(1<<PB1)|(1<<PB0);
	DDRB &= ~(1<<PB3);

	//enable chipselectpin PE3
	DDRE |= (1<<PE3);

	/* Enable SPI, Master, set clock rate fck/2 */

	
	SPCR = (1<<SPE)|(1<<MSTR);

	SPSR |= (1<<SPI2X);

}

unsigned char SPI_transmit(unsigned char data){

	// Start transmission
	SPDR = data;

	// Wait for transmission complete
	while(!(SPSR & (1<<SPIF)));

	return(SPDR);
}

unsigned char SPI_receive(void){


	SPDR = 0xff;
	while(!(SPSR & (1<<SPIF)));

	return SPDR;
}


