
/* rev 1.0 03/2010 				written by Anders Guldahl			     */
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include "buzzer.h"
#include "timer0.h"
	
void InitBuzzer(void){
	
	
	PORTB &= ~(1<<PB4);
	DDRB |= (1<<PB4);
	
	TCNT2 = 0x00;
	OCR2A = 0x7D;
	
	TCCR2A = (1<<WGM21)|(1<<COM2A0);
	
	
}	
	
	
void TurnBuzzerOn(unsigned char duration){
	
	OCR2A = 16;
	unsigned int prescaler = 256;

	switch(prescaler){
		case 64:
			TCCR2A |= (1<<CS22);	
		break;
		case 256:
			TCCR2A |= (1<<CS22)|(1<<CS21);
		break;
		case 128:
			TCCR2A |= (1<<CS22)|(1<<CS20);
		break;
		case 1024:
			TCCR2A |= (1<<CS22)|(1<<CS21)|(1<<CS20);
		break;
		default:
			TCCR2A |= (1<<CS22)|(1<<CS21);
		break;
	
	}
	Timer0RegisterCallback(buzzerOffCallback, duration);
	
}	

void buzzerOffCallback(void){
	static unsigned char counter = 0;
	counter++;

	if(counter>1){
		TurnBuzzerOff();
		Timer0RemoveCallback(buzzerOffCallback);
		counter = 0;
	}
}
	
void TurnBuzzerOff(void){
	
	TCCR2A &= ~((1<<CS21)|(1<<CS20)|(1<<CS22));
	
}

void PlayClick(void){
	TCNT2 = 0x00;
	OCR2A = 91;
	TCCR2A |= (1<<CS22)|(1<<CS21);
	ENABLE_TIMER2_COMP_INT;
	
}



volatile unsigned int compare_counter = 0;

ISR(TIMER2_COMP_vect){
	
	compare_counter++;
	if(compare_counter >1){
		compare_counter = 0;
		TurnBuzzerOff();
		DISABLE_TIMER2_COMP_INT;
	}

}
