

#include "cruise.h"
#include "can.h"
#include "../common_files/status_structs.h"



void setCruiseSafety(int input){

	if(input>=0 && input < 2){
		cruise_control.safety_off_active = input;
	}
}

void setCruiseMaxSpeed(int input){
	
	if(input>=0 && input < 101){
		cruise_control.cruise_max_speed = input;
	}
}

void CruiseControl(void){
	
	static unsigned char last_speed = 0;
	static unsigned char cruise_turned_off = 1;
	static unsigned char cruise_turned_on = 1;
	static unsigned char motor_on = 0;
	union can_frame send;

	

	if(cruise_control.safety_off_active && signals_lights.pedal_position <= 5){
		cruise_control.cruise_active = 0;
		signals_lights.black_one = 0;
	}

	if(cruise_control.cruise_active){
		
		cruise_turned_off = 0;
		if(last_speed != cruise_control.set_speed || cruise_turned_on == 1){
			cruise_turned_on = 0;
			last_speed = cruise_control.set_speed;
			

		}
	}else{
		if(last_speed != signals_lights.pedal_position){
			last_speed = signals_lights.pedal_position;
		
			cruise_turned_off = 1;
			cruise_turned_on = 1;
		
			send.id = 0x6C3;			
			send.length = 1;
			send.rbr = 0;
			send.rb0 = 0;
			send.data[0] = last_speed;
			send_can_frame(&send);

		}
	}
	/*
	if(motor_on == 0 && send.data[0] != 0){
		motor_on = 1;
		send.id = 0x6C2;			
		send.length = 1;
		send.rbr = 0;
		send.rb0 = 0;
		send.data[0] = 1;
		send_can_frame(&send);
	}else if(motor_on == 1){
		motor_on = 0;
		send.id = 0x6C2;			
		send.length = 1;
		send.rbr = 0;
		send.rb0 = 0;
		send.data[0] = 0;
		send_can_frame(&send);
	
	}
	*/


}

void CruiseOnPressed(void){

	


	

	if(signals_lights.black_one == 0){
		signals_lights.black_one = 1;
		cruise_control.cruise_active = 1;
		
		union can_frame send;
		send.id = 0x6C2;			
		send.length = 1;
		send.rbr = 0;
		send.rb0 = 0;
		send.data[0] = 1;
		send_can_frame(&send);

		if(cruise_control.set_speed == 0){//only use pedal position if set speed is 0 (aka. probably not set)
			if(signals_lights.pedal_position < cruise_control.cruise_max_speed){
				cruise_control.set_speed = signals_lights.pedal_position;
			}
			else{
				cruise_control.set_speed = cruise_control.cruise_max_speed;
			}
		}
	}
	else{
		signals_lights.black_one = 0;
		cruise_control.cruise_active = 0;
		
	}
	signals_lights.values_changed = 1;	

}


void IncreaseCruiseSpeed(void){
	if(cruise_control.set_speed < cruise_control.cruise_max_speed){
		cruise_control.set_speed++;
		union can_frame send;
		send.id = 0x6C3;			
		send.length = 1;
		send.rbr = 0;
		send.rb0 = 0;
		send.data[0] = cruise_control.set_speed;
		send_can_frame(&send);
	}
		
}


void DecreaseCruiseSpeed(void){
	if(cruise_control.set_speed > 0){
		cruise_control.set_speed--;
		union can_frame send;
		send.id = 0x6C3;			
		send.length = 1;
		send.rbr = 0;
		send.rb0 = 0;
		send.data[0] = cruise_control.set_speed;
		send_can_frame(&send);
	}		
		
}
