
// main.h
#ifndef _MAIN_H_
#define _MAIN_H_

unsigned char StateMachine(char state, unsigned char stimuli);
char ShowMenu(char input);

#define BOOL    char

#ifndef FALSE
#define FALSE   0
#define TRUE    (!FALSE)
#endif

#ifndef NULL
// mt/ca:
// #define NULL    0
#define NULL ((void *)0)
#endif

#define AUTO    3
#define HORN_PERIOD 40

// Macro definitions
//mtA - 
// sbi and cbi are not longer supported by the avr-libc
// to avoid version-conflicts the macro-names have been 
// changed to sbiBF/cbiBF "everywhere"
#define sbiBF(port,bit)  (port |= (1<<bit))   //set bit in port
#define cbiBF(port,bit)  (port &= ~(1<<bit))  //clear bit in port
//mtE

// Menu state machine states
#define ST_MENU_STATUS                     10
#define ST_MENU_OPTIONS                    21


void sendCANmsgLights(void);
void IndicatorLights(void);
void SoundHorn(void);
void SendStatusMsg(unsigned char status);
void ResetModuleStatus(int reset_node_number);
void HandleButtonPushes(unsigned char panel_buttons, unsigned char wheel_buttons);
void HandleButtonLED(void);
void FanCallback(void);
void setFanSlowSpeed(int input);
void setFanFastSpeed(int input);
void setLoadAutoOff(int input);
void setFanFastTime(int input);
void FuelCellStartedCallback(void);
void SetDefaultValues(void);
#endif //_MAIN_H_
