// menu.h
#ifndef _MENU_H_
#define _MENU_H_
#include <avr/pgmspace.h>

#define KEY_NULL    0
#define KEY_UP		1
#define KEY_DOWN    2
#define KEY_PUSH    3

#define ST_MAIN_MENU 			10
#define ST_OPTIONS_MENU 		20

#define ST_DRIVE	 			30
#define ST_STATUS_TWO	 		32
#define ST_STATUS_FUELCELL 		34
#define ST_STATUS_MOTOR	 		36
#define ST_STATUS_GPS	 		38
#define ST_STATUS_LOG		 	40
#define ST_LIGHTS_MENU	 		42
#define ST_MATRIX				50
#define ST_PURGE				60

#define MAIN_MENU_LENGTH 12
#define OPTIONS_MENU_LENGTH 10
#define LIGHTS_MENU_LENGTH 6

typedef struct
{
	unsigned char show_cursor; //0: no cursor, 1 cursor on left side, 2 cursor on right side
	PGM_P pMenuText;
} MAIN_MENU_ELEMENTS;


typedef struct
{
	unsigned char show_cursor; //0: no cursor, 1 cursor on left side, 2 cursor on right side
	PGM_P pMenuText;
    int value;
	int value_min;
	int value_max;
	unsigned char value_changed;
	void (*pFunc)(int input);


}SETUP_MENU_ELEMENTS;

typedef struct
{
	int cursor_position;
	int top_position;
	unsigned char redraw_needed;
	unsigned char redraw_cursor_needed;
	unsigned char redraw_value_needed;
	int last_cursor_position;

}DRAW_MENU_STATUS;





int LcdScreenStateMachine(int cursor_movement, unsigned char enc_push);
int DrawMainMenu(int cursor_movement);
int DrawSetupMenu(int cursor_movement, unsigned char element_selected, SETUP_MENU_ELEMENTS* menu_elements, unsigned char menu_length, DRAW_MENU_STATUS* draw_menu_status);



void clear_cursors(void);
void clear_values(void);


int DrawDrive(int cursor_movement);
int DrawStatus(int input);
int DrawFuelCellStatus(int input);
int DrawMotorStatus(int input);
int DrawGpsStatus(int input);
int DrawLog(int input);
int DrawLightStatus(int input);
int DrawMatrix(int input);
void DrawSymbol(char x, char y, char symbol);
void HandleOptionMenuChanges(void);
void HandleLightsMenuChanges(void);
void MenuSetDefaultValues(void);

#endif //_MENU_H_
