/* rev 1.0 12/2009 				written by Anders Guldahl			     */
#include <stdio.h>

#include <inttypes.h>
#include <avr/io.h>
/*************************************************************************
* description:  uartdriver for avr 128
**************************************************************************/
#include <avr/interrupt.h>
#include "macro.h"
#include "uart_debug.h"


void USART_Init_debug(void){
	unsigned int brr;


	brr = BAUDREG_debug;

	/* Set baud rate */
	UBRR0H = (unsigned char)(brr>>8);
	UBRR0L = (unsigned char)brr;

	UCSR0A |= (1<<U2X0);
	/* Enable receiver and transmitter */
	UCSR0B = (1<<RXEN0)|(1<<TXEN0);

	/* Set frame format: 8data, 1stop bit */
	UCSR0C = (3<<UCSZ00);


	stdout = uart;
	fdevopen (&USART_Transmit_debug, &USART_Receive_debug);

	USART_Flush_debug();

}

int USART_Transmit_debug( unsigned char data){
	/* Wait for empty transmit buffer */
	while ( !( UCSR0A & (1<<UDRE0)) );

	/* Put data into buffer, sends the data */
	UDR0 = data;
	return 0;
}

unsigned char USART_Receive_debug(){
	/* Wait for data to be received for a little time */
	unsigned char count = 0;
	while ( !(UCSR0A & (1<<RXC0)) ){
		count++;
		if(count>240){
			return -1;
		}
	}

	/* Get and return received data from buffer */
	return UDR0;
}


void USART_Flush_debug( void )
{
    unsigned char dummy;
    while ( UCSR0A & (1<<RXC0) ) dummy = UDR0;
}



