/* rev 1.0 2/2010			written by Anders Guldahl			     */
#include <stdio.h>

#include <inttypes.h>
#include <avr/io.h>
/*************************************************************************
* description:  uartdriver for avr 128
**************************************************************************/
#include <avr/interrupt.h>
#include "macro.h"
#include "uart_BT.h"


void USART_Init_BT(void){
	unsigned int brr;


	brr = BAUDREG_BT;

	/* Set baud rate */
	UBRR1H = (unsigned char)(brr>>8);
	UBRR1L = (unsigned char)brr;

	UCSR1A |= (1<<U2X1);
	/* Enable receiver and transmitter */
	UCSR1B = (1<<RXEN1)|(1<<TXEN1);

	/* Set frame format: 8data, 1stop bit */
	UCSR1C = (3<<UCSZ10);

/*
	stdout = uart;
	fdevopen (&USART_Transmit_debug, &USART_Receive_debug);
*/

}

void USART_Transmit_BT( unsigned char data){


	/* Put data into buffer, sends the data */
	UDR1 = data;

		/* Wait for empty transmit buffer */
	unsigned char count = 0;
	while ( !( UCSR1A & (1<<UDRE1)) ){
		count++;
		if(count>254){
			return;
		}
	
	}
	
	
}

unsigned char USART_Receive_BT(void){
	/* Wait for data to be received for a little time */
	unsigned char count = 0;
	while ( !(UCSR1A & (1<<RXC1)) ){
		count++;
		if(count>240){
			return -1;
		}
	}

	/* Get and return received data from buffer */
	return UDR1;
}


void USART_Transmit_BT_string(char * string, unsigned char length){
	
	int i;
	for(i = 0; i<length;i++){
		
		if(string[i]=='\0'){
			break;
		}
		USART_Transmit_BT(string[i]);
	}


}



