

#include "can.h"
#include "can_fuelcell_msg.h"
#include "temp_converting.h"




void SendDataOverCAN( int cell_voltage[], int temperature[], int pressure_sensor[], unsigned char output[]){	

	//send cellvoltages
		
	DATA data;
	int i,j;
	unsigned char k,inc;
	inc = 0;
	union can_frame send;

	for(j = 0;j<NUM_CELLS;j++){
		
		send.data[((j%4)*2)] = cell_voltage[j]>>8;
		send.data[((j%4)*2)+1] = cell_voltage[j] & 0x00FF;

		
		if(j%4 == 3 ){
			
			send.id = 0x700+inc;
			send.length = 8;
			send.rbr = 0;
			send.rb0 = 0;
		
			
			send_can_frame(&send);	
			inc++;
		}	
	
	}

		
	send.id = 0x700+inc;
	send.length = 8;
	send.rbr = 0;
	send.rb0 = 0;

	send_can_frame(&send);	

	//send temperatures
	
	inc = 0;
	for(j = 0;j<NUM_TEMPS;j++){

		send.data[((j%4)*2)] = (ConvertTemp(temperature[j]))>>8;
		send.data[((j%4)*2)+1] = (ConvertTemp(temperature[j])) & 0x00FF;

		
		if(j%4 == 3 ){
			
			send.id = 0x70C+inc;
			send.length = 8;
			send.rbr = 0;
			send.rb0 = 0;
		
			
			send_can_frame(&send);	
			inc++;
		}	
	
	}


	//send currentloopsensors

	inc = 0;
	//the last pressure is actually stack voltage after boardfailure and fix
	for(j = 0;j<NUM_PRESSURE;j++){

		send.data[((j%4)*2)] = pressure_sensor[j]>>8;
		send.data[((j%4)*2)+1] = pressure_sensor[j] & 0x00FF;

	}

	send.id = 0x70F;
	send.length = 8;
	send.rbr = 0;
	send.rb0 = 0;

	
	send_can_frame(&send);

	//send output_status
	
	for(j = 0;j<5;j++){

		send.data[j] = output[j];
	
	}

	send.id = 0x710;
	send.length = 5;
	send.rbr = 0;
	send.rb0 = 0;

	
	send_can_frame(&send);	
	


}
