/* rev 1.0 12/2009 				written by Anders Guldahl			     */
// SOURCE FILE : SPI_routines.c

#include <avr/io.h>
#include "SPI_routines.h"

//SPI initialize for SD card

void spi_init(void){

	/* Set MOSI and SCK and pb0 output, all others input */
	DDRB |= (1<<DDB3)|(1<<DDB2)|(1<<DDB1)|(1<<DDB0);
	/* Enable SPI, Master, set clock rate fck/64 */
	//increased later to get higher speed
	//need low speed to initialise sd-card spi_mode
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR1)|(1<<SPR0);

	SPSR |= (1<<SPI2X);
	/* Set chipselect high*/
	SD_CS_DEASSERT;
}

unsigned char SPI_transmit(unsigned char data){

	// Start transmission
	SPDR = data;

	// Wait for transmission complete
	while(!(SPSR & (1<<SPIF)));

	return(SPDR);
}

unsigned char SPI_receive(void){


	SPDR = 0xff;
	while(!(SPSR & (1<<SPIF)));

	return SPDR;
}

