/* rev 1.0 12/2009 				written by Anders Guldahl			     */
#ifndef __INCLUDE_status_led_H__
#define __INCLUDE_status_led_H__

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>
#include "macro.h"
#include "status_led.h"


#define RED 3
#define GREEN 5
#define BLUE 6
#define YELLOW 1
#define MAGENTA 2
#define CYAN 4
#define WHITE 0
#define ORANGE 8
#define LED_OFF 7

#define ENABLE_TM2OVF_INT TIMSK2 |= (1<<TOIE2)
#define DISABLE_TM2OVF_INT TIMSK2 &= ~(1<<TOIE2)


void init_status_led(void);


void set_status_led(char color);

void set_status_rgb(unsigned char red, unsigned char green, unsigned char blue);

void heart_beat(char on);

void slow_breathing(char on);

void fast_breathing(char on);
unsigned int get_system_ticks(void);

#endif //ifndef __INCLUDE_status_led_H__
