/* rev 1.0 12/2009 				written by Anders Guldahl			     */
#ifndef __INCLUDE_telit_H__
#define __INCLUDE_telit_H__

extern const char cr_P[];

extern const char line_P[];

extern const char menu_option_P[];
extern const char prompt_P[];
extern const char error_unknown_command_P[];
extern const char got_P[];

extern const char ok_P[];
extern const char no_response_P[];
extern const char no_fix_P[];
extern const char error_P[];
extern const char interactive_P[];
extern const char run_P[];
extern const char wait_P[];

// modem strings
extern const char AT_P[];					// say hello
extern const char OK_P[];			// response

extern const char ATCMEE_P[];			// extended error format


extern const char ATGPSR_P[];			// reset GPS, warm start
extern const char ATGPSACP_P[];			// position request

extern const char ATCGDCONT_P[];
extern const char ATSCFG_P[];

extern const char ATCGATT_P[];  //gprs attached ?

extern const char ATSD_P[]; //socketdial
extern const char CONNECT_response[];

extern const char ATSGACT_P_enable[];
extern const char ATSGACT_P_disable[];
extern const char ATSGACT_P_query[];

extern const char ATSH_P[];
extern const char ATSO_P[];

extern const char NO_CARRIER_P[];
extern const char ESCAPE_SOCKET_P[];



unsigned char uart_gets_timeout(char *buf, uint16_t timeout);

void init_telit_pwr_switch(void);

unsigned char telit_pwr_switch_on(void);
unsigned char telit_pwr_switch_off(void);

void telit_pwr_reset(void);

/*
 * Sends a request to the modem and stores the response into
 * the buffer.
 */
unsigned char request_modem(const char *command, uint16_t timeout, unsigned char check, char *buf);

/*
 * Gets a response from the modem.
 */
unsigned char uart_gets_timeout(char *buf, uint16_t timeout);

unsigned char gprs_connect(void);
unsigned char gprs_is_connected(void);
unsigned char gprs_disconnect(void);

unsigned char open_socket(void);
unsigned char close_socket(void);
unsigned char resume_socket(void);
unsigned char suspend_socket(void);

unsigned char telit_attention(void);

unsigned char get_gps_string(char *buf);


#endif //ifndef __INCLUDE_telit_H__
