/* rev 1.0 12/2009 				written by Anders Guldahl			     */
#include <stdio.h>

#include <inttypes.h>
#include <avr/io.h>
/*************************************************************************
* description:  uartdriver for avr 128
**************************************************************************/
#include <avr/interrupt.h>
#include "macro.h"
#include "uart_debug.h"


void USART_Init_debug(void){
	unsigned int brr;


	brr = BAUDREG_debug;

	/* Set baud rate */
	UBRR1H = (unsigned char)(brr>>8);
	UBRR1L = (unsigned char)brr;

	UCSR1A |= (1<<U2X1);
	/* Enable receiver and transmitter */
	UCSR1B = (1<<RXEN1)|(1<<TXEN1);

	/* Set frame format: 8data, 1stop bit */
	UCSR1C = (3<<UCSZ10);


	stdout = uart;
	fdevopen (&USART_Transmit_debug, &USART_Receive_debug);

	USART_Flush_debug();

}

int USART_Transmit_debug( unsigned char data){
	
	unsigned char count = 0;
	/* Put data into buffer, sends the data */
	UDR1 = data;
	/* Wait for empty transmit buffer */
	while ( !( UCSR1A & (1<<UDRE1)) ){
		count++;
			if(count>250){
				return -1;
			}
	}
	
	
	return 0;
}

unsigned char USART_Receive_debug(){
	/* Wait for data to be received for a little time */
	unsigned char count = 0;
	while ( !(UCSR1A & (1<<RXC1)) ){
		count++;
		if(count>240){
			return -1;
		}
	}

	/* Get and return received data from buffer */
	return UDR1;
}


void USART_Flush_debug( void )
{
    unsigned char dummy;
    while ( UCSR1A & (1<<RXC1) ) dummy = UDR1;
}



